/* File: CHRTDEMO.H
 *
 * Allgemeine Definitionen fr die wichtigen Module in CHRTDEMO.
 */


/* --- Fr Grafikadapter, die zur Farbdarstellung fhig sind: --- */
#define C_INPUTCOLOR  11      /* Farbe fr Dateneingabe                 */
#define C_HILITECOLOR 10      /* Farbe fr erhellte Anfangsbuchstaben   */
#define C_FORMCOLOR   15      /* Farbe fr Rahmenlinien und Hilfezeilen */
#define C_TITLECOLOR  15      /* Farbe fr QuickCHART-Titel             */
#define C_ERRORCOLOR  14      /* Farbe fr Fehlermeldungen              */
#define C_INFOCOLOR    7      /* Farbe fr nicht eingegebene Daten      */

/* --- Fr Grafikadapter, die nicht zur Farbdarstellung fhig sind: --- */
#define M_INPUTCOLOR   7      /* Farbe fr Dateneingabe                 */
#define M_HILITECOLOR 15      /* Farbe fr erhellte Anfangsbuchstaben   */
#define M_FORMCOLOR    7      /* Farbe fr Rahmenlinien und Hilfezeilen */
#define M_TITLECOLOR  15      /* Farbe fr QuickCHART-Titel             */
#define M_ERRORCOLOR  15      /* Farbe fr Fehlermeldungen              */
#define M_INFOCOLOR    7      /* Farbe fr nicht eingegebene Daten      */

/* Makros, um festzustellen ob Adapter zur Farbdarstellung fhig ist. */
#define ismono(m) ( ((m) == _MRESNOCOLOR) || ((m) == _HRESBW)      || \
                    ((m) == _HERCMONO)    || ((m) == _ERESNOCOLOR) || \
                    ((m) == _VRES2COLOR) )
#define iscolor(m) (!ismono(m))

/* ASCII-Codes fr hufig benutzte Steuerfunktionen. */
#define SIGNAL        7
#define ESCAPE     27

/* Konstanten-Grenzwerte */
#define MAXWERTE  12
#define MAXFOLGEN  4

typedef enum tagBool { FALSCH, WAHR } BOOL;

/* Konstanten zur Schriftsatz-Identifizierung gegenber SchriftWahl. */

enum tagSchriftArt
{
    COURIER,
    HELV,
    TMS_RMN,
    MODERN,
    SCRIPT,
    ROMAN
};


/* Die Variablen zum Verfolgen von Steuerung und Bildschirmposition.  */
struct SCREENINFO
{
    int  top;              /* Reihe unterhalb oberster Formzeile     */
    int  bot;              /* Reihe ber unterster Formzeile         */
    int  mid;              /* Mittlere Linie der Form                */
    int  help;             /* Zeilennumer der Hilfezeile             */
    int  mode;             /* Gegenwrtiger Bildschirmmodus          */
    int  xMax;
    int  yMax;
    BOOL fFarbe;
} ;

/* Diese Variablen enthalten entweder fr Farbgrafikadapter #definierte
 * Konstanten (in der Form C_xxxxxCOLOR) oder die fr Momonchromadapter
 * #definierte Konstanten (in der Form M_xxxxxCOLOR). Sie steuern aber
 * NICHT die Farbe der Diagrammgrafik, nur die der Mens und
 *  Bedienerfhrung.
 */
struct tagFarbe
{
    short EingabeFarbe;            /* Farbe fr Eingabeaufforderungen     */
    short HellFarbe;               /* Farbe fr erhellte Bedienerfhrung  */
    short FormFarbe;               /* Farbe fr Eingabeschablonen & Mens */
    short TitelFarbe;              /* Farbe fr Titel                     */
    short FehlerFarbe;             /* Farbe fr Fehlermeldungen           */
    short InfoFarbe;               /* Farbe fr Informationsmeldungen     */
} ;


/* Funktionsprototypen */
void Achse( axistype *pat );
void Achsen( void );
void AchsenBereich( axistype *pat );
void AchsenEinteilung( axistype *pat );
void AchsenSkala( axistype *pat );
void AndereSchrift( void );
void AusgabePos(int row, int column, char far * lpszString, short sFarbe);
void Ausrichten( titletype *ptt );
void Beschriftung( void );
void BeschriftungStelle( void );
int  BlankMenue( char *pchTitel, char *pchWahl1, char *pchWahl2 );
void BschirmModus( void );
void ClrForm( void );
void LschHilfe( void );
void DatenFenster( void );
void DatenLoeschen( BOOL fWirklich );
void Demo( void );
int  DiagrammAnsicht( void );
void DiagrammFenster( void );
void DiagrammOpt( void );
void DiagrammTyp( void );
char EingabeChar( char *pchPrompt, char *pchAccept );
float EingabeFloat( char *pchPrompt, float fAlt );
int  EingabeInt( char *pchPrompt, int iAlt, int iMin, int iMax );
char *EingabeString( char *pchPrompt, char *pchAlt );
void FehlerMeldg( char *pchMsg );
void Fenster( void );
void FensterFormat( windowtype *pwt );
void HauptMenue( void );
void Hilfe( char *pchMsg, short sFarbe );
BOOL InBereich( int Wert, int iMin, int iMax );
void Initialisiere( void );
int  main( void );
int  Menue( char *pszMenuList[] );
void PopTitel( void );
void PrintChar(int row, int column, char cChar, short sFarbe);
void PushTitel( char *pchAltTitle );
void Rand( windowtype *pwt );
void RuecksetzOptionen( void );
void SAusgabePos( int iReihe, int iSplt, char * szFmt, ... );
void SchriftOptionen( void );
void SchriftWahl( int WelcheSchrift, int Hoch );
void SetDisplayColors( void );
BOOL SetGraphMode( int mode );
void Titel( void );
void TitelOpt( titletype *ptt );
void VorgabeDaten( short iTyp, short iStil, BOOL fLoesch );
void WrtForm( int yBot );
int  ZeigeAchsenTyp( int iReihe, int iSplt, axistype dieAchse );
int  ZeigeBeschriftungTyp( int iReihe, int iSplt, legendtype dieBeschriftung );
void ZeigeBspielDaten( void );
void ZeigeDiagrammDaten( void );
int  ZeigeFensterTyp( int iReihe, int iSplt, windowtype dasFenster );
void ZeigeFehler( int iErr );
int  ZeigeTitelTyp( int iReihe, int iSplt, titletype derTitel );

/* Konstanten-Grenzwerte. */
#define MAXWERTE  12
#define MAXFOLGEN  4
