/* CHRTSUPT.C - Untersttzungsmodul fr das Diagrammgrafik-Beispielprogramm */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <conio.h>
#include <graph.h>
#include <pgchart.h>
#include <stdarg.h>
#include "diagdemo.h"

/* Variablen zur Menverwaltung.  */
int cMenueEbene = 0;                 /* Gegenwrtige Menebene   */
char *szMenueTitel[10];              /* Stapel von Mentiteln */

char *pszBlankMenue[4];

/* Die Variablen zum Verfolgen von Steuerung und Bildschirmposition.  */
struct SCREENINFO si;

/* */
struct tagFarbe co;

/*  BlankMen - Holt Antworten zu zwei bestimmten Wahlmglichkeiten.
 *
 *  Parameter: pchTitel - Titelzeichenfolge fr Men
 *             pchWahl1 - Zeichenfolge fr Wahlmglichkeit 1
 *             pchWahl2 - Zeichenfolge fr Wahlmglichkeit 2
 *
 *  Ergibt:    Return: Anzahl der Wahlmglichkeiten oder ESCAPE
 */
int BlankMenue( char *pchTitel, char *pchWahl1, char *pchWahl2 )
{
    int iWahl;

    /* Titel und Wahlmglichkeiten initialisieren.  */
    pszBlankMenue[0] = pchTitel;
    pszBlankMenue[1] = pchWahl1;
    pszBlankMenue[2] = pchWahl2;
    pszBlankMenue[3] = "\0";
    PushTitel( pszBlankMenue[0]);

    while( WAHR )
    {
    /* Nur Anfangsbuchstaben einer der Wahlmglichkeiten akzeptieren,
     * oder ESC.
     */
     iWahl = Menue( pszBlankMenue );
        switch( iWahl )
        {
            case 1:
            case 2:
            case ESCAPE:
                return iWahl;
        }
    }
}

/*  LschForm - Lscht den Innenbereich der Bildschirmanzeige
 *
 *  Parameter: Keine
 */
void LschForm()
{

    /* Bildschirm-Teilausschnitt einrichten und lschen, dann ganzen
     * Bildschirm rcksetzen.
     */
    _settextwindow( si.top, 1, si.bot, 80 );
    _clearscreen( _GWINDOW );
    _settextwindow( 1, 1, 25, 80 );

}

/*  LschHilfe - Clears the current help Zeile.
 *
 *  Parameter: None
 */
void LschHilfe()
{
    /* Hilfezeilenzhler um 1 verringern und die Zeile lschen.  */
    _settextwindow( --si.help, 1, si.help, 80 );
    _clearscreen( _GWINDOW );
    _settextwindow( 1, 1, 25, 80 );
}

/*  FehlerMldg - Bringt eine Fehlermeldung.
 *
 *  Parameter: pchMdg - Zeichenfolge der Fehlermeldung
 */
void FehlerMldg( char *pchMdg )
{

    /* Warnsignal, Fehlerfarbe festlegen, dann Fehlermeldung und
     * 'Weiter'-Frage ausgeben.
     */
    putch( SIGNAL );
    Hilfe( pchMdg, co.FehlerFarbe );
    Hilfe( "Weiter durch Drcken beliebiger Taste.", co.FehlerFarbe );

    /* Auf Tastendruck warten und Hilfezeilen lschen.  */
    getch();
    LschHilfe();
    LschHilfe();

}

/*  Hilfe - Zeigt eine Hilfezeile auf dem Bildschirm.
 *
 *  Parameter: pchMdg - Zeichenfolge der Fehlermeldung
 *             sFarbe - Farbe fr Meldung
 */
void Hilfe( char *pchMdg, short sFarbe )
{

    struct rccoord rcCursor;

    /* Gegenwrtige Cursorposition speichern.  */
    rcCursor = _gettextposition();

   /* Hilfezeile ausgeben und Hilfezeilen-Positionsvariable um 1 erhhen. */
    AusgabePos( si.help++, 5, pchMdg, sFarbe );

    /* Cursorposition wiederherstellen.  */
    _settextposition( rcCursor.row, rcCursor.col );

}

/*  EingabeChar - Fragt nach und ergibt Eingabezeichen.
 *
 *  Parameter: pchFrage  - Zeichenfolge fr Anfrage
 *             pchAkzept - Zeichenfolge akzeptabler Zeichen (Gro- und
 *                         Kleinschreibung werden unterschieden)
 *
 *  Ergibt:    Eingegebenes Zeichen
 */
char EingabeChar( char *pchFrage, char *pchAkzept )
{
    char chAntwort;

    /* Anfrage ausgeben.  */
    AusgabePos( si.mid, 10, pchFrage, co.EingabeFarbe );

    /* Schleife weiterfhren bis Antwort gltig ist.  */
    while( WAHR )
    {
        chAntwort = toupper( getch() );

        /* Zeichen anzeigen und ergeben, wenn gltig, sonst Warnsignal.  */
        if( *strchr( pchAkzept, chAntwort) )
        {
         _settextcolor( co.InfoFarbe );
            putch( chAntwort );
            return chAntwort;
        }
        else
         putch( SIGNAL );
    }
}

/*  EingabeInt - Fragt nach und ergibt Ganzzahlwert innerhalb eines
 *  bestimmten Bereiches.
 *
 *  Parameter: pchFrage - Zeichenfolge fr Anfrage
 *             iAlt - Voriger Wert
 *             iMin - Mindestwert des Bereichs
 *             iMax - Hchstwert des Bereichs
 *
 *  Ergibt:    Vom Benutzer eingegebene Ganzzahl
 */
int EingabeInt( char *pchFrage, int iAlt, int iMin, int iMax )
{
    int i;
    char szTmp[70];

    /* Zur Eingabe einer Zeichenfolge auffordern, diese dann zu Ganzzahl
     * umwandeln bis sich ein Wert innerhalb des bestimmten Bereichs ergibt.
     * Diesen Wert schlielich ergeben.
     */
    do
    {
     EingabeString( pchFrage, itoa( iAlt, szTmp, 10) );
        i = atoi( szTmp );
    } while( !InBereich( i, iMin, iMax) );
    return i;
}

/*  EingabeFloat - Fordert zur Eingabe eines Gleitkommawerts auf und
 *               ergibt diesen.
 *
 *  Parameter: pchFrage - Zeichenfolge fr Aufforderung
 *             fAlt - Voriger Wert
 *
 *  Ergibt:    Vom Benutzer eingegebene Gleitkommazahl
 */
float EingabeFloat( char *pchFrage, float fAlt )
{
    char szTmp[70];

    /* Zur Eingabe einer Zeichenfolge auffordern, zu Gleitkomma umwandeln */
    sprintf( szTmp, "%f", fAlt );
    EingabeString( pchFrage, szTmp );
    return atof( szTmp );
}

/*  EingabeString - Aufforderung zur Eingabe einer Zeichenfolge. Bis erstes
 *  Zeichen eingegeben ist, wird vorige Zeichenfolge gezeigt, dann durch
 *  neue Eingabe ersetzt.
 *
 *  Parameter: pchFrage - Zeichenfolge fr Aufforderung
 *             pchAlt   - Zwischenspeicher fr vorige Zeichenfolge; mu gro
 *                        genug fr neue Zeichenfolge sein.
 *
 *  Ergibt:    Zeiger zu pchAlt, wo nun neue Zeichenfolge vorliegt
 */
char *EingabeString( char *pchFrage, char *pchAlt )
{
    char szTmp[81], ch;
    int x = 5, y = si.mid;

    /* Aufforderung in Ausschnittmitte ausgeben.  */
    LschForm();
    AusgabePos( y, x, pchFrage, co.EingabeFarbe );
    x += strlen( pchFrage );

    /* Vorigen Wert zur Bezugnahme ausgeben.  */
    _outtext( pchAlt );
    _settextposition( y, x );

    /* Auf Eingabe warten, danach alte Zeichenfolge lschen.  */
    while( !(ch = kbhit()) )
        ;
    memset( szTmp, ' ', 80 );
    szTmp[80] = '\0';
    AusgabePos( y, x, szTmp, -1 );

    /* Neue Zeichenfolge holen und zu Ergebnis machen. Wenn Null-
     * Zeichenfolge (EINGABE-Taste gedrckt), ist alter Wert das Ergebnis.
     */
    _settextcolor( co.InfoFarbe );
    _settextposition( y, x );
    szTmp[0] = 70;             /* Einlesebare Maximallnge */
    cgets( szTmp );
    if( szTmp[1] > 0 )         /* Wurden berhaupt Zeichen eingelesen?  */
    {
        strcpy( pchAlt, &szTmp[2] );
        return &szTmp[2];
    }
    else
    {
        _settextposition( y, x );
        return pchAlt;
    }
}

/*  InBereich - Prft ob Ganzzahl innerhalb des bestimmten Bereichs liegt.
 *
 *  Parameter: iWert - Zu prfende Ganzzahl
 *             iMin  - Mindestwert des Bereichs
 *             iMax  - Hchstwert des Bereichs
 *
 *  Ergibt:    WAHR sofern innerhalb des Bereichs, sonst FALSCH
 */
BOOL InBereich( int Value, int iMin, int iMax )
{
    /* Bereich prfen und WAHR ergeben wenn gltig, sonst FALSCH. Bitte zu
     * beachten, da (iMin >= iMax) nur als Anweisung verstanden wird, auf
     * den Mindestwert zu prfen; Hchstwert gibt es keinen.
     */
    if( Value >= iMin )
        if( (Value <= iMax) || (iMin >= iMax) )
         return WAHR;
    else
    {
     FehlerMldg( "Ungltiger Wert." );
     return FALSCH;
    }
}

/* Men - Zeichnet Men auf Bildschirm; ergibt Anzahl der Wahlmglichkeiten.
 *
 * Parameter: Datenfeld der Men-Zeichenfolgen
 *
 * Ergibt: Zahl fr die aus dem Men getroffene Wahl
 */
int Menue( char *pszMenueListe[] )
{
    int iItem, cItem, yItem, x = 10;
    char chAntwort;

    /* Men-Wahlmglichkeiten zhlen.  */
    for( cItem = 1; *pszMenueListe[cItem]; cItem++ )
        ;
    --cItem;


    /* Form lschen und Wahlmglichkeiten des Mens ausgeben.  */
    WrtForm( 10 + cItem );
    for( iItem = 1, yItem = 8; iItem <= cItem; iItem++, yItem++ )
    {
     AusgabePos( yItem, x, pszMenueListe[iItem], co.EingabeFarbe );
     PrintChar( yItem, x, pszMenueListe[iItem][0], co.HellFarbe );
    }
    ++yItem;

    /* Aufforderung und Hilfe anzeigen.  */
    if( strcmpi( pszMenueListe[0], "Hauptmen" ) )/* Falls nicht Hauptmen */
     Hilfe( "Anfangsbuchstaben Ihrer Wahl eingeben, bzw. zurck mit ESC.",
            co.EingabeFarbe );
    else
     Hilfe( "Anfangsbuchstaben Ihrer Wahl eingeben; mit \"E\" beenden.",
            co.EingabeFarbe );

    AusgabePos( yItem, x += 5, "Ihre Wahl? ", co.InfoFarbe );
    x += 11;

    /* Schleife bis zu brauchbarer Wahl; Warnsignal bei ungltiger Wahl. */
    while( WAHR )
    {
        _settextposition( yItem, x );
        chAntwort = toupper( getch() );

        /* Zurck - aufgrund Drcken von ESC.  */
        if( chAntwort == 27 )
        {
            LschHilfe();
            return ESCAPE;
        }

        /* Unter Wahlmglichkeit nach entsprechendem Anfangsbuchstaben
         * suchen. Dann betreffende Wahlmglichkeit als Ergebnis ausgeben
         * und Hilfezeile lschen.
         */
        for( iItem = 1; iItem <= cItem; iItem++ )
        {
         if( chAntwort == toupper( pszMenueListe[iItem][0]) )
            {
                putch( chAntwort );
                LschHilfe();
                return iItem;
            }
        }

        /* Hierher kommt man nur, wenn keine brauchbare Wahlmglichkeit
         * gefunden wurde; deshalb Warnsignal und Vorgang wiederholen.
         */
     putch( SIGNAL );
    }
}

/*  PopTitel - Einen Mentitel aus dem Menstapel entnehmen.
 *
 *  Parameter: Keine
 */
void PopTitel()
{
    szMenueTitel[--cMenueEbene] = "";
}

/*  AusgabePos - Druckt an den bestimmten Koordinaten (Reihe/Spalte)
 *            eine Zeichenfolge in der festgelegten Farbe .
 *
 *  Parameter: row        - Reihe wo Ausgabe der Zeichenfolge beginnen soll
 *             col        - Spalte wo Ausgabe der Zeichenfolge beginnen soll
 *             lpszString - Null-abgeschlossene Zeichenfolge
 *             sFarbe     - Farbe zur Ausgabe der Zeichenfolge (-1 wenn
 *                          AusgabePos die Farbe unverndert belassen soll)
 */
void AusgabePos(int row, int column, char far * lpszString, short sFarbe)
{
    if( sFarbe != -1L )
        _settextcolor( sFarbe );
    _settextposition( row, column );
    _outtext( lpszString );
}

/*  PrintChar - Druckt an den bestimmten Koordinaten (Reihe/Spalte)
 *              eine Zeichenfolge in der festgelegten Farbe .
 *
 *  Parameter: row        - Reihe wo Ausgabe der Zeichenfolge beginnen soll
 *             col        - Spalte wo Ausgabe der Zeichenfolge beginnen soll
 *             cChar      - Zu druckendes Zeichen
 *             sFarbe     - Farbe zur Ausgabe der Zeichenfolge (-1 wenn
 *                          AusgabePos die Farbe unverndert belassen soll)
 */
void PrintChar(int row, int column, char cChar, short sFarbe)
{
    char szTiny[2];

    szTiny[0] = cChar;
    szTiny[1] = '\0';
    AusgabePos( row, column, szTiny, sFarbe );
}

/*  PushTitel - Legt einen Mentitel zuf den Menstapel.
 *
 *  Parameter: pchTitel - abzulegende Titelzeichenfolge
 */
void PushTitel( char *pchTitel )
{
    szMenueTitel[cMenueEbene++] = pchTitel;
}

/*  SetDisplayColors - Farben auf Wert einrichten, die dem vorhandenen
 *                     Videoadapter entsprechen.
 *
 * Parameter: Keine
 */
void SetDisplayColors()
{
    if( ismono( si.mode ) )
    {
     co.EingabeFarbe  = M_INPUTCOLOR;
     co.HellFarbe = M_HILITECOLOR;
     co.FormFarbe   = M_FORMCOLOR;
     co.TitelFarbe  = M_TITLECOLOR;
        co.FehlerFarbe  = M_ERRORCOLOR;
     co.InfoFarbe   = M_INFOCOLOR;
    }
    else
    {
     co.EingabeFarbe  = C_INPUTCOLOR;
     co.HellFarbe = C_HILITECOLOR;
     co.FormFarbe   = C_FORMCOLOR;
     co.TitelFarbe  = C_TITLECOLOR;
        co.FehlerFarbe  = C_ERRORCOLOR;
     co.InfoFarbe   = C_INFOCOLOR;
    }
}

/*  SAusgabePos - Zeichenfolge ber sprintf() formatieren und mit
 *             AusgabePos zum Bildschirm ausgeben.
 *
 *  Parameter: iReihe  - Reihe, wo Anzeige anfangen soll
 *             iSplt   - Spalte, and der Anzeige anfangen soll
 *             szFmt   - Formatierfolge (fr richtige Schreibweise von
 *                       Formatierfolgen siehe Begleitliteratur der
 *                       Laufzeitbibliothek).
 *             ...     - Auszugebende Variablen
 */
void SAusgabePos( int iReihe, int iSplt, char * szFmt, ... )
{
    char szTmp[81];
    va_list Marke;
    va_list saveMarke;

    va_start( Marke, szFmt );
    saveMarke = Marke;
    vsprintf( szTmp, szFmt, Marke );
    va_end( Marke );

    AusgabePos( iReihe, iSplt, szTmp, -1 );
}

/*  WrtForm - Zeigt Bildschirmformat.
 *
 *  Parameter: yBot - Reihennummer der untersten Reihe
 */
void WrtForm( int yBot )
{
    int i;
    char szTmp[81];

    /* Rechts oben die Copyright-Meldung ausgeben.  */
    _clearscreen( _GCLEARSCREEN );
    AusgabePos( 1, 55, "Diagrammgrafik - Demo", co.TitelFarbe );

    /* Die obere Trennzeile lschen.  */
    memset( szTmp, ' ', 79 );
    szTmp[79] = 0;
    AusgabePos( 2, 55, "(C) 1990, Microsoft", co.TitelFarbe );

    /* Alle ebenen des Mentitels anzeigen.  */
    _settextposition( 5, 5 );
    for( i = 0; i < cMenueEbene; i++ )
    {
        if( i )
            _outtext( " - " );
     _outtext( szMenueTitel[i] );
    }

    /* Obere Trennzeile anzeigen.  */
    memset( szTmp, 196, 80 );
    szTmp[80] = 0;
    AusgabePos( 6, 1, szTmp, co.FormFarbe );

    /* Untere Trennzeile anzeigen.  */
    AusgabePos( yBot, 1, szTmp, co.FormFarbe );

    /* Globale Bildschirm-Variablen einrichten.  */

    si.help = yBot + 1;
    si.top = 7;
    si.bot = yBot - 1;
    si.mid = (si.top + si.bot) / 2;
}
