/* Funktionsprototypen, Makros, Strukturen und globale Variablen fr
 * Mens und dazu verwandte Funktionen
 */

/* Nur einmal einfgen */
#ifndef MENU_H
#define MENU_H


#define WAHR   1
#define FALSCH 0

/* Tastencode-Beispiele fr getkey. Im gleichen Format knnen weitere
 * Codes hinzugefgt werden.
 */
#define U_UP    0x0148      /* Ohne UMSCH */
#define U_DN    0x0150
#define U_LT    0x014b
#define U_RT    0x014d
#define S_UP    0x0248      /* mit UMSCH */
#define S_DN    0x0250
#define S_LT    0x024b
#define S_RT    0x024d

#define N_PLUS  0x014e      /* PLUS und MINUS auf Zahlentastenblock */
#define N_MINUS 0x014a

#define EINGABE     13      /* ASCII */

/* Aktionscodes fr getkey */
enum AKTIONSCODE { NO_WAIT, WAIT, CLEAR_WAIT };

/* Text-Ausgabefarben. Beachten Sie, da fr Monochrom nur _TBLACK
 * _TWHITE, _TBRIGHTWHITE und _TUNDERLINE verwendbar sind und da
 * Schwarz/Wei-Grafik davon nur die ersten drei verwenden kann. Die
 * ersten acht Farben knnen Hintergundfarben sein (sie mssen aber
 * mglicherweise auf Typ long umgewandelt werden).
 */
enum TEXTFARBEN
{
    _TBLACK,        _TBLUE,         _TGREEN,        _TCYAN,
    _TRED,          _TMAGENTA,      _TBROWN,        _TWHITE,
    _TGREY,         _TLIGHTBLUE,    _TLIGHTGREEN,   _TLIGHTCYAN,
    _TLIGHTRED,     _TLIGHTMAGENTA, _TLIGHTYELLOW,  _TBRIGHTWHITE,
    _TUNDERLINE = 1
};
#define _TUNDERLINE 1

/* Struktur und Globalvariablen fr Menattribute */
typedef struct _MENU
{
    int     fgRand, fgNormal, fgAuswahl, fgNormalHell, fgWahlHell;
    long    bgRand, bgNormal, bgAuswahl, bgNormalHell, bgWahlHell;
    int     fMittig;
    unsigned char   chNW, chNE, chSE, chSW, chNS, chEW;
} MENU;
extern MENU mnuAtrib;

/* Struktur und Hchstlnge fr Men-Wahlmglichkeiten */
#define MAXITEM 25
typedef struct _ITEM
{
    int     iErhellt;
    char    achItem[MAXITEM];
} ITEM;

/* Globale Men-, Ausgabe- und Eingabe-Funktionen */
int Menue( int row, int col, ITEM aItem[], int iCur );
int EventSchleife( int row, int col, ITEM aItem[], int iCur, int CItem,
		   int cchItem, int acchItem[], char accHilite[]);
void Box( int row, int col, int rowLetzt, int colLetzt );
unsigned GetKey( int fWait );
void _outchar( char out );

#endif /* MENU_H */
