/* TOOLS.H - Enthlt Definitionen allgemeine Konstanten und Makros, sowie 
 * Konstanten und Prototypen fr Funktionen in TOOLS.C
 */

#define WAHR   1
#define FALSCH 0

/* Text-Ausgabefarben. Bitte zu beachten, da fr Monochrom nur 
 * _TBLACK _TWHITE, _TBRIGHTWHITE und _TUNDERLINE verwendbar sind
 * und da Schwarz/Wei-Grafik davon nur die ersten drei verwenden
 * kann. Die ersten acht Farben knnen Hintergundfarben sein (sie 
 * mssen aber mglicherweise auf Typ long umgewandelt werden).
 */
enum TEXTFARBEN
{
    _TBLACK,        _TBLUE,         _TGREEN,        _TCYAN,
    _TRED,          _TMAGENTA,      _TBROWN,        _TWHITE,
    _TGREY,         _TLIGHTBLUE,    _TLIGHTGREEN,   _TLIGHTCYAN,
    _TLIGHTRED,     _TLIGHTMAGENTA, _TLIGHTYELLOW,  _TBRIGHTWHITE,
};
#define _TUNDERLINE 1

/* Makros zum Kombinieren von Hintergund- und Vordergrundfarben, sowie 
 * von Cursor-Anfangs- und -End-Reihen.
 */
#define SETATRIB( fore, back )   ( ((back) << 4) | (fore))
#define SETCURSOR( first, last ) ( ((first) << 8) | (last))

/* Aktionscodes fr getkey */
enum AKTIONSCODE { NO_WAIT, WAIT, CLEAR_WAIT };

/* Prototypen der Funktionen in TOOLS.C */
void delay( clock_t wait );
unsigned getkey( int waitflag );
